/*
 *   Object Oriented Programming with C++
 *   BLG332E
 *   2nd Homework
 *   Copyleft, March 2006
 *
 */
#include "ATM.h"

bool ATM::insertCreditCard(CreditCard *cc){
     if (isInserted) return false;
     if (!cc) return false;
     if (cc->isBlocked) return false;
     creditCard= cc;
     isInserted= true;
     return true;
}

bool ATM::ejectCreditCard(){
     if (!isInserted) return false;
     isInserted= false;
     numberOfFaults= 0;
     creditCard= 0L;
     totalAmountInOneSession= 0;
     return true;
}

int ATM::withdraw(double amt){
     if (!isInserted) return -1;
     if (amt<=0.0) return -1;
     int intAmount= static_cast<int>(amt);
     if (amt!=intAmount) return 3;
     if (intAmount%10) return 3;
     if ((totalAmountInOneSession+intAmount)>500) return 4;
     if (intAmount>totalBankNoteInAtm) return 2;      
     Customer *customer = bank->getCustomer(creditCard->customerID);
     AccountWithCreditCard *acc= static_cast<AccountWithCreditCard *>(customer->getAccount());
     if (acc->withdraw(static_cast<double>(intAmount))){
	int withdrawAmount= intAmount;      
	int withrawBanknote[4]={0};
	for (int slotNumber=3;slotNumber>=0;slotNumber--){
	    if (!slots[slotNumber]) continue;
            while (withdrawAmount/banknote[slotNumber]){
	          withrawBanknote[slotNumber]++; 	
	          withdrawAmount-= banknote[slotNumber];
		  slots[slotNumber]--;
	          if (!slots[slotNumber]) break;
	    }
	}
     }
     else { 
       return 1;
     }
     totalAmountInOneSession+= intAmount;
     totalBankNoteInAtm-= intAmount;
     return 0;
}

bool ATM::enterPinCode(int pin_code){
     if (!isInserted) return false;
     AccountWithCreditCard *acc= static_cast<AccountWithCreditCard*>
	  (bank->getCustomer(creditCard->customerID)->getAccount()) ;
     if (acc->pinCode==pin_code) return true;
     numberOfFaults++;
     if (numberOfFaults==3){
        creditCard->block();
        blockedCards[numberOfBlockedCards++]= creditCard; 
        isInserted= false;
        numberOfFaults= 0;
        creditCard= 0L;
     }
     totalAmountInOneSession= 0;
     return true;
}

double ATM::getBalance() const {
    if (!isInserted) return 0.0;	
    return bank->getCustomer(creditCard->customerID)->getAccount()->getBalance() ;
}
