/*
 *   Object Oriented Programming with C++
 *   BLG332E
 *   2nd Homework
 *   Copyleft, March 2006
 *
 */
#include "Bank.h"
#include "AccountWithCreditCard.h"
#include "CreditCard.h"

#include <iostream>
using namespace std;

#ifndef __ATM__
#define __ATM__

#define MAX_BLOCKED_CARDS 16

class ATM {
      friend class Bank;
      private:
         int banknote[4];
         bool isInserted;
	 int  numberOfFaults;
	 int  totalBankNoteInAtm; 
	 int totalAmountInOneSession;
         int slots[4];
         CreditCard *blockedCards[MAX_BLOCKED_CARDS];
         int numberOfBlockedCards;
      protected:
         Bank *bank;
         int customerID ;
         CreditCard *creditCard;
      public:
         ATM(Bank *bank){
           this->bank= bank;
	   isInserted= false;
	   numberOfFaults= 0;
	   totalAmountInOneSession= 0;
	   totalBankNoteInAtm=0;
	   banknote[0]=10;
	   banknote[1]=25;
	   banknote[2]=50;
	   banknote[3]=100;
	   for (int i=0;i<4;i++){ 
	       slots[i]=100;
	       totalBankNoteInAtm+= slots[i] * banknote[i];
	   } 
           numberOfBlockedCards=0;
         }
         bool insertCreditCard(CreditCard *);
         bool enterPinCode(int);
         bool ejectCreditCard();
         int withdraw(double) ;
         double getBalance() const ;
 };
#endif
