/*
 *
 *   Object Oriented Programming 
 *   BIL332E
 *   2nd Homework
 *   You can edit this file
 *   Add lines to test the behavior of your classes
 *
 */
#include <iostream>
using namespace std;

// this files are provided to you
#include "Bank.h"
#include "Customer.h"
#include "Account.h"

// you will write these files
#include "AccountWithCreditCard.h"
#include "ATM.h"

int main(int argc,char *argv[]){
    Bank *bank = new Bank();
    Customer *customer;
    Account *account;

    //
    // Create bank customers and their accounts
    //

    cout << endl << "Creating the customer Jane Smith.";
    bank->addCustomer("Jane", "Simms");
    customer = bank->getCustomer(0);
    cout << endl << "Creating her Account with a 500.00 balance and pin code 1234.";
    customer->setAccount(new AccountWithCreditCard(5000.00,1234)); 

    cout << endl << "Creating the customer Owen Bryant.";
    bank->addCustomer("Owen", "Bryant");
    customer = bank->getCustomer(1);
    cout << endl << "Creating his Account with a 500.00 balance and pin code 9876.";
    customer->setAccount(new AccountWithCreditCard(5000.00,9876));
    
    cout << endl << "Creating the customer Tim Soley.";
    bank->addCustomer("Tim", "Soley");
    customer = bank->getCustomer(2);
    cout << endl << "Creating his Checking Account with a 500.00 balance and 500.00 in overdraft protection.";
    customer->setAccount(new AccountWithCreditCard(800.0, 7643));

    
    cout << endl << "Creating the customer Maria Soley.";
    bank->addCustomer("Maria", "Soley");
    customer = bank->getCustomer(3);
    cout << customer->getFirstName() << endl ;
    cout << endl << "Maria shares her Checking Account with her husband Tim.";
    customer->setSharedAccount(bank->getCustomer(2)->getAccount());

    cout << endl ;

    //
    // Demonstrate behavior of accounts
    //

    // Test an Account
    cout << endl << "Retrieving the customer Jane Smith with her account->";
    customer = bank->getCustomer(0);
    account = customer->getAccount();
    // Perform some account transactions
    cout << endl << "Withdraw 150.00: " << (account->withdraw(150.00)?"true":"false");
    cout << endl << "Deposit 22.50: " << (account->deposit(22.50)?"true":"false");
    cout << endl << "Withdraw 47.62: " << (account->withdraw(47.62)?"true":"false");
    cout << endl << "Withdraw 400.00: " << (account->withdraw(400.00)?"true":"false");
    // Print out the final account balance
    cout << endl << "Customer [" << customer->getLastName()
		       << ", " << customer->getFirstName()
		       << "] has a balance of " << account->getBalance();

    cout << endl ;

    // Test another account 
    cout << endl << "Retrieving the customer Owen Bryant with his account";
    customer = bank->getCustomer(1);
    account = customer->getAccount();
    // Perform some account transactions
    cout << endl << "Withdraw 150.00: " << (account->withdraw(150.00)?"true":"false");
    cout << endl << "Deposit 22.50: " << (account->deposit(22.50)?"true":"false");
    cout << endl << "Withdraw 47.62: " << (account->withdraw(47.62)?"true":"false");
    cout << endl << "Withdraw 400.00: " << (account->withdraw(400.00)?"true":"false");
    // Print out the final account balance
    cout << endl << "Customer [" << customer->getLastName()
		       << ", " << customer->getFirstName()
		       << "] has a balance of " << account->getBalance() ;

    cout << endl;

    // Test another Account
    cout << endl << "Retrieving the customer Tim Soley with his account.";
    customer = bank->getCustomer(2);
    account = customer->getAccount();
    // Perform some account transactions
    cout << endl << "Withdraw 150.00: " << (account->withdraw(150.00)?"true":"false");
    cout << endl << "Deposit 22.50: " << (account->deposit(22.50)?"true":"false");
    cout << endl << "Withdraw 47.62: " << (account->withdraw(47.62)?"true":"false");
    cout << endl << "Withdraw 400.00: " << (account->withdraw(400.00)?"true":"false");
    // Print out the final account balance
    cout << endl << "Customer [" << customer->getLastName()
		       << ", " << customer->getFirstName()
		       << "] has a balance of " << account->getBalance();

    cout << endl ;

    // Test an Account
    cout << endl << "Retrieving the customer Maria Soley with her joint account with husband Tim.";
    customer = bank->getCustomer(3);
    account = customer->getAccount();
    // Perform some account transactions
    cout << endl << "Deposit 150.00: " << (account->deposit(150.00)?"true":"false");
    cout << endl << "Withdraw 750.00: " << (account->withdraw(750.00)?"true":"false");
    // Print out the final account balance
    cout << endl << "Customer [" << customer->getLastName()
		       << ", " << customer->getFirstName()
		       << "] has a balance of " << account->getBalance();
    cout << endl ;
    // Test ATM
    ATM *patm= new ATM(bank);
    
    customer = bank->getCustomer(1);
    AccountWithCreditCard *acc= static_cast<AccountWithCreditCard*>(customer->getAccount());    
    CreditCard *creditCard= acc->getCreditCard();
    //CreditCard stealCreditCard= *creditCard; // should cause compile error!

    if (patm->insertCreditCard(creditCard)){
       cout << "You have successfully inserted credit card." << endl ; 
    }
  
    if (!patm->enterPinCode(9876)){
       cout << "You enter wrong code" << endl ; 
       cout << "If you enter wrong code three times your card will be held by the machine" << endl ; 
    } 
  
    switch (patm->withdraw(390.0)){
	    case 1: cout << "Your balance do not cover that much amount" << endl ; 
		    break;
	    case 2: cout << "ATM machine cannot cover that amount" << endl ;
		    break;
	    case 3: cout << "The amount should be multiple of 10YTL" << endl ;
		    break;
	    case 4: cout << "You cannot withdraw more than 500YTL in one session" << endl ;
		    break;
    } 
   
    cout << "Your balance is " << patm->getBalance() << endl ;
    
    if (!patm->insertCreditCard(creditCard)){
       cout << "You cannot insert creadit card while another one has already been inserted." << endl ; 
    }
    
    patm->ejectCreditCard();
    delete patm;
    delete bank;
}
